local quartz = {}

function quartz:Hook(module)
	if not Quartz then return end
	if not Quartz:HasModule("Target") then return end
	if module ~= true and module ~= Quartz:GetModule("Target") then return end
	self.UNIT_SPELLCAST_START = Deadened.UNIT_SPELLCAST_START
	
	if Quartz and Quartz:IsModuleActive("Target") then
		local QuartzTarget = Quartz:GetModule("Target")
		if not Deadened:IsHooked(QuartzTarget, "UNIT_SPELLCAST_START") then
			Deadened:Hook(QuartzTarget, "UNIT_SPELLCAST_START", "UNIT_SPELLCAST_START", true)
			Deadened:Hook(QuartzTarget, "PLAYER_TARGET_CHANGED", "UNIT_SPELLCAST_START", true)
		end
	end
end

function quartz:Unhook(module)
	if not Quartz then return end
	if not Quartz:HasModule("Target") then return end
	if module ~= true and module ~= Quartz:GetModule("Target") then return end
	
	if Quartz and Quartz:HasModule("Target") and Quartz:IsModuleActive("Target") and Deadened:IsHooked(Quartz:GetModule("Target"), "UNIT_SPELLCAST_START") then
		local QuartzTarget = Quartz:GetModule("Target")
		Deadened:Unhook(QuartzTarget, "UNIT_SPELLCAST_START")
		Deadened:Unhook(QuartzTarget, "PLAYER_TARGET_CHANGED")
	end
end

Deadened:AddHandler("Quartz", quartz)